/***************************************************************************
                          creiserpart.h  -  description
                             -------------------
    begin                : Thu Jul 13 2000
    copyright            : (C) 2000 by Franois Dupoux
    email                : fdupoux@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CREISERPART_H
#define CREISERPART_H

#include "partimage.h"
#include "common.h"
#include "misc.h"

struct CImage;
struct CVolumeHeader;
struct CMainFooter;
struct CMainHeader;
struct COptions;
class CSaveWindow;
class CRestoreWindow;

#define CURRENT_REISER_FORMAT					  "0.2" // format version of the fat image
#define MAX_REISER_BLOCK_SIZE						8192
// ================================================
struct CReiserHeader // size must be 16384 (adjust the reserved data)
{
	char szAppFormat[20]; // Version of the format of the application file
	DWORD dwReiserFlags;
	char szLabel[64];
	
	DWORD dwBlockSize;
	DWORD dwUsedBlocks;
	DWORD dwBlocksCount;
	DWORD dwBitmapBlocksCount;

	unsigned char cReserved[16280]; // Adjust to fit with total header size
};

// ================================================
class CReiserPart
{
public:
	CReiserPart(char *szDevice, FILE *fDeviceFile);
	~CReiserPart();
	
	// save options
	int saveToImage(CImage *image, COptions *options, CSaveWindow *gui);

	// restore options
	int restoreFromImage(CImage *image, COptions *options, CRestoreWindow *gui);
	
private:
	int printfInformations();
	int readInformations();
	int saveUsedBlocksToImageFile(COptions *options);
	int restoreUsedBlocksToDisk(COptions *options);
	int copyBitmap(COptions *options);

private:
	CImage *m_image;
	CBlocksUseBitmap m_bitmap;
	CSaveWindow *m_guiSave;
	CRestoreWindow *m_guiRestore;
	
	char m_szDevice[MAX_DEVICENAMELEN+1]; // "/dev/hdc5"
	char m_szImageFilename[MAXPATHLEN+1]; // ex: /home/user/filename.partimg.gz.002 (if splitted)
	char m_szOriginalFilename[MAXPATHLEN+1]; // ex: filename.partimg.gz
	char m_szPath[MAXPATHLEN+1]; // ex: /home/user/
	
	// informations
	DWORD m_dwBlockSize;
	DWORD m_dwUsedBlocks;
	DWORD m_dwBlocksCount;
	DWORD m_dwBitmapBlocksCount;
	
	// volumes
	DWORD m_dwCurrentVolumeSize;
	DWORD m_dwVolumeNumber;
		
	// File descriptors
	FILE *m_fDeviceFile;
};

#endif // CREISERPART_H
