/***************************************************************************
                          gui_text.h  -  description
                             -------------------
    begin                : Tue Aug 22 2000
    copyright            : (C) 2000 by Franois Dupoux
    email                : fdupoux@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "partimage.h"

#include <newt.h>

int guiInitMainWindow(char *szDevice, char *szImageFile);
void askDescription(char *szDescription, DWORD dwMaxLen);
int askText(char *szMessage, char *szTitle, char *szDestText);
void showAboutDialog();
int fillPartitionList(newtComponent editPartition);

// =======================================================
class CSaveWindow
{
public:
	int create(char *szDevice, char *szImageFile, COptions options);
	void showDetectedFS(char *szFs);
	void showPartitionInfo(char *szDevice, QWORD qwSize);
	void showAvaibleSpaceForImage(QWORD qwFreeSpace);
	int runForm();
	void destroyForm();
	int getValues(COptions *options);
void CSaveWindow::setProgressValue(QWORD qwSaved, QWORD qwTotal);
	void showImageFileInfo(char *szImageFile, QWORD qwFreeSpace, QWORD qwImageSize);
	
private:
	newtComponent m_formMain;
	newtComponent m_labelPartition, m_labelImageFile, m_labelFS;
	newtComponent m_labelCompression, m_labelOptions, m_labelSplit;
	newtComponent m_labelFreeSpace;
	newtComponent m_radioCompNone, m_radioCompGzip, m_radioCompBzip2;
	newtComponent m_radioSplitNone, m_radioSplitSize, m_radioSplitSize2, m_radioSplitAuto;
	newtComponent m_checkCheckBeforeSaving, m_checkAskDesc, m_checkOverwrite;
	newtComponent m_editSplitSize;
	newtComponent m_progressSaving, m_labelPercent;
	newtComponent m_btnSave, m_btnExit;
	newtComponent m_labelFinish, m_radioFinishWait, m_radioFinishHalt, m_radioFinishReboot;


};

// =======================================================
class CRestoreWindow
{
public:
	int create(char *szDevice, char *szImageFile, COptions options);
	void showPartitionInfo(char *szDevice, QWORD qwSize);
	void showPartitionInfos(DWORD dwCompressionMode, char *szOriginalDevice, char *szFileSystem, tm dateCreate, QWORD qwPartSize);
	int runForm();
	void destroyForm();
	int getValues(COptions *options);
	void setProgressValue(QWORD qwRestoredBlocks, QWORD qwUsedBlocks, QWORD qwTotalBlocks, bool bEraseWithNull);
	void showSplittedInfo(char *szState);
	void showFS(char *szFs);
	void showImageFileInfo(char *szImageFile);
	
private:
	newtComponent m_formMain;
	newtComponent m_labelPartition, m_labelImageFile, m_labelFS, m_labelCompression;
	newtComponent m_labelOriginalSize, m_labelDate, m_labelOldDevice, m_labelOptions;
	newtComponent m_checkEraseWithNull, m_labelSplit;
	newtComponent m_progressRestoring, m_labelPercent;
	newtComponent m_btnRestore, m_btnExit;
	newtComponent m_labelFinish, m_radioFinishWait, m_radioFinishHalt, m_radioFinishReboot;

};

