/***************************************************************************
                          imagefile.h  -  description
                             -------------------
    begin                : Mon Aug 14 2000
    copyright            : (C) 2000 by Franois Dupoux
    email                : fdupoux@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IMAGEFILE_H
#define IMAGEFILE_H

#include "partimage.h"

class CSaveWindow;
class CRestoreWindow;

// ================================================
class CImage
{
public:
	CImage() {m_bIsOpened = false;}

public:
	// split informations
	DWORD m_dwCurrentVolumeSize;
	DWORD m_dwVolumeNumber;
	bool m_bIsSplitted;
	bool m_bIsOpened;
	
	// filename of the image
	char m_szImageFilename[MAXPATHLEN]; // ex: "/home/user/filename.partimg.gz.002" (if splitted)
	char m_szOriginalFilename[MAXPATHLEN]; // ex: "filename.partimg.gz"
	char m_szPath[MAXPATHLEN]; // ex: "/home/user/"
	
	QWORD m_qwCRC;
	DWORD m_dwCompression;

private:
	gzFile m_gzImageFile;
	FILE *m_fImageFile;
	BZFILE *m_bzImageFile;
	
	CSaveWindow *m_guiSave;
	CRestoreWindow *m_guiRestore;
	
public:
	// read/write
	DWORD write(void *buf, DWORD dwLength, COptions options, bool bUpdateCRC); // return 0 if error, or written bytes
	DWORD read(void *buf, DWORD dwLength, bool bSplitted, COptions options, bool bUpdateCRC); // return 0 if error, or read bytes
	
	// open/close
	int openWriting(COptions options);
	int openReading(COptions options);
	int close();
	
	// magic strings
	int readAndCheckMagic(char *szMagicString, COptions options);
	int writeMagic(char *szMagicString, COptions options);
	
	// GUI
	void setGuiSave(CSaveWindow *gui);
	void setGuiRestore(CRestoreWindow *gui);
	
	// misc
	QWORD ftell();
	
private:
	// split
	int splitChangeImageFileRead(COptions options);
	int splitChangeImageFileWrite(COptions options, bool bAskPath);
};

#endif // IMAGEFILE_H
