/***************************************************************************
                          misc.h  -  description
                             -------------------
    begin                : Sun Jul 16 2000
    copyright            : (C) 2000 by Franois Dupoux
    email                : fdupoux@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MISC_H
#define MISC_H

#include "partimage.h"

int isMounted(const char *szDevice, char *szMountPoint);
QWORD getPartitionSize(const char *szDevice);
char *formatSize(QWORD qwSize, char *szText);
void askDescription(char *szDescription, DWORD dwMaxLen);
int detectFileSystem(const char *szDevice, char *szFileSys);
int checkInodeForDevice(char *szDevice);
int extractFilenameFromFullPath(char *szFullpath, char *szFilename);
int extractFilepathFromFullPath(char *szFullpath, char *szFilepath);
QWORD getFileSize(char *szFilename);
int getDiskFreeSpaceForFile(QWORD *qwAvailDiskSpace, const char *szFilename);
int getCompressionLevelForImage(char *szFilename);
int bigFseek(FILE *fStream, QWORD qwOffset); // SEEK_SET forced
char *decodePartitionEntry(char *cPtr, int *nMajor, int *nMinor, int *nBlocks, int *nPartNum, char *szDevice);

// =======================================================
class CBlocksUseBitmap
{
public:
    CBlocksUseBitmap();
    ~CBlocksUseBitmap();
    
public:
    int setBit(DWORD dwBit, bool bState);
    int isBitSet(DWORD dwBit);

    int init(DWORD dwBlocksCount);
    int freeBitmap();

    int fill(BYTE cValue);
    BYTE *data();
    DWORD dataSize();
    DWORD crc(QWORD qwClustersCount);

private:
    BYTE *m_cBitmap;
    DWORD m_dwBitmapSize;
};


#endif //MISC_H

