/***************************************************************************
                          parttable.cpp  -  description
                             -------------------
    begin                : Sat Sep 9 2000
    copyright            : (C) 2000 by Franois Dupoux
    email                : fdupoux@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "parttable.h"

#include <stdio.h>
#include <string.h>
#include <errno.h>

// =======================================================
int printPartTable(char *szDevice)
{
	CMbr mbr;
	FILE *fDevice;
	int nRes;
	int i;
	
	// ------------------ read MBR -----------------
	errno = 0;
	fDevice = fopen(szDevice, "rb");
	if (!fDevice)
	{	printf("Cannot open partition %s (%s)\n", szDevice, strerror(errno));
		return -1;
	}

	errno = 0;
	nRes = fread(&mbr, sizeof(CMbr), 1, fDevice);
	if (nRes != 1)
	{	printf("Cannot read mbr (%s)\n", strerror(errno));
		return -1;
	}

	// ------------------ decode data -----------------
	CMbrPartEntry encoded;
	CPart decoded;
	printf ("Partition   Size\n");
	
	for (i=0; i < 4; i++)
	{	
		encoded = mbr.part_rec[i];
		
		if (encoded.cFsId) // if partition is used
		{
			unpackPartitionRecord(&encoded, &decoded);
			//printf ("%s%d   %ld\n", szDevice, i+1, encoded.dwSectInPart);
		
		
		}
	}
	
	// ------------------ close partition -----------------
	
	fclose(fDevice);
	return 0;
}

/*struct CMbrPartEntry // Partition record in MBR
{
	unsigned char  cState;
	unsigned char  cStartHead;
	unsigned short nStartSect;
	unsigned char  cFsId;
	unsigned char  cEndHead;
	unsigned short nEndSect;
	unsigned long  dwSectBeforePart;	// Number os sectors prior to partition
	unsigned long  dwSectInPart;	// Number of sectors in the partition

};*/
	
// =======================================================
int unpackPartitionRecord(CMbrPartEntry *encoded, CPart *decoded)
{
	decoded->cFsId      = encoded->cFsId << 8;
	decoded->dwFlags    = 0;
	decoded->nTag       = encoded->cActive;

	decoded->dwStartHead = encoded->cStartHead; // easy, just copy
	
	// TODO: 2 lines
	//decoded->dwStartSect = encoded->nStartSectCyl;
	//decoded->dwStartCyl  = encoded->nStartSectCyl+(encoded->nStartSectCyl<<8);

	decoded->dwEndHead   = encoded->cEndHead;
	
	// TODO: 2 lines
	//decoded->dwEndSect    = encoded->nEndSectCyl+(encoded->nEndSectCyl<<8);
	//decoded->dwEndCyl   = encoded->nEndSectCyl;

	decoded->dwSectBeforePart   = encoded->dwSectBeforePart;
	decoded->dwSectInPart   = encoded->dwSectInPart;

	// TODO: what is it ?
	// find_fs_num( decoded );
	
	return 0;
}
