/***************************************************************************
                          parttable.h  -  description
                             -------------------
    begin                : Sat Sep 9 2000
    copyright            : (C) 2000 by Franois Dupoux
    email                : fdupoux@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "partimage.h"

// =======================================================
struct CPart
{
	DWORD dwFlags;
	UINT  nFsNum;	// fs number in the file system type table
	UINT  cFsId;
	UINT  nMbrRow;
	UINT  nTag;

	DWORD dwStartHead;
	DWORD dwStartSect;
	DWORD dwStartCyl;

	DWORD dwEndHead;
	DWORD dwEndSect;
	DWORD dwEndCyl;

	DWORD dwSectBeforePart;
	DWORD dwSectInPart;
 	DWORD last_sect;
	DWORD ext_base;

	DWORD rel_sect_loaded;
	void  *part_boot_sect;
	void  *part_misc_info;
};

// =======================================================
struct CMbrPartEntry // Partition record in MBR
{
	BYTE  cActive;
	BYTE  cStartHead;
	UINT  nStartSectCyl;
	BYTE  cFsId;
	BYTE  cEndHead;
	UINT  nEndSectCyl;
	DWORD dwSectBeforePart;	// Number os DWORDs prior to partition
	DWORD dwSectInPart;	// Number of DWORDs in the partition

};

// =======================================================
struct CMbr
{
	BYTE  code[0x1AE];
	DWORD bm_chs;
	DWORD fd_chs;
	DWORD bm_rel_sect;
	BYTE  ipl_timeout;
	BYTE  ipl_default;
	UINT  bm_magic2; // 'BM' = 0x4D42

	CMbrPartEntry   part_rec[4];
	UINT  magic_num;  // Magic number (must be 0xAA55)
};

// =======================================================
int printPartTable(char *szDevice);
int unpackPartitionRecord(CMbrPartEntry *encoded, CPart *decoded);

